<?php  
if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) { die('You are not allowed to call this page directly.'); }

function divvaflip_admin_overview()  {	
	global $wpdb;
	
	// get feed_messages
	require_once(ABSPATH . WPINC . '/rss.php');
	
	// init PluginChecker
	$nggCheck 			= new CheckPlugin();	
	$nggCheck->URL 		= NGGURL;
	$nggCheck->version 	= NGGVERSION;
	$nggCheck->name 	= "ngg";

?>
  <div class="wrap" style="overflow:hidden;">
    <h2><?php _e('1DivvaFlip-4U Overview', 'divvaflip') ?></h2>
        
    <div id="zeitgeist">
    	  <h2><?php _e('Summary', 'divvaflip') ?></h2>
      <p>
         <?php
          $replace = array
          (
            '<strong>'.$wpdb->get_var("SELECT COUNT(*) FROM $wpdb->nggpictures").'</strong>',
            '<strong>'.$wpdb->get_var("SELECT COUNT(*) FROM $wpdb->divvaflip").'</strong>',
            '<strong>'.$wpdb->get_var("SELECT COUNT(*) FROM $wpdb->nggalbum").'</strong>'
           );              
          vprintf(__('There are totally %1$s pictures in %2$s galleries, which are spread across %3$s albums.', 'divvaflip'), $replace);
        ?>
       </p>
	  <?php if ( $nggCheck->startCheck() && (!IS_WPMU) ) { ?>
		<h3><font color="red"><?php _e('New Version available', 'divvaflip') ?></font></h3>
	   	<p><?php _e('The server reports that a new 1DivvaFlip-4U Version is now available. Please visit the plugin homepage for more information.', 'divvaflip') ?></p>
		<p><a href="http://wordpress.org/extend/plugins/divvaflip/download/" target="_blank"> <?php _e('Download here', 'divvaflip') ?> </a></p>
	  <?php } ?>
	  <?php if (IS_WPMU) {
	  	if (wpmu_enable_function('wpmuQuotaCheck'))
			echo ngg_SpaceManager::details();
	  } else { ?>
	  	<h3><?php _e('Server Settings', 'divvaflip') ?></h3>
      <ul>
      	<?php ngg_get_serverinfo(); ?>
	   </ul>
		<?php ngg_gd_info(); ?>
	  <?php } ?>
    </div>
    
    <h3><?php _e('Welcome', 'divvaflip') ?></h3>
    
    <p>
      <?php
        $userlevel = '<strong>' . (current_user_can('manage_options') ? __('gallery administrator', 'divvaflip') : __('gallery editor', 'divvaflip')) . '</strong>';
        printf(__('Welcome to 1DivvaFlip-4U . Here you can control your images, galleries and albums. You currently have %s rights.', 'divvaflip'), $userlevel);
      ?>
    </p>
    
    <ul>
      <?php if(current_user_can('1DivvaFlip-4U Upload images')): ?><li><a href="admin.php?page=divvaflip-add-gallery"><?php _e('Add a new gallery or import pictures', 'divvaflip') ?></a></li><?php endif; ?>
      <?php if(current_user_can('1DivvaFlip-4U Manage gallery')): ?><li><a href="admin.php?page=divvaflip-manage-gallery"><?php _e('Manage galleries and images', 'divvaflip') ?></a></li><?php endif; ?>
      <?php if(current_user_can('1DivvaFlip-4U Edit album')): ?><li><a href="admin.php?page=divvaflip-manage-album"><?php _e('Create and manage albums', 'divvaflip') ?></a></li><?php endif; ?>
      <?php if(current_user_can('1DivvaFlip-4U Change options')): ?><li><a href="admin.php?page=divvaflip-options"><?php _e('Change the settings of 1DivvaFlip-4U ', 'divvaflip') ?></a></li><?php endif; ?>
    </ul>
    <div id="devnews">
    <h3><?php _e('Latest News', 'divvaflip') ?></h3>
    
    <?php
      $rss = fetch_rss('http://am211.amanager.net/?tag=divvaflip?feed=rss2');
      
      if ( isset($rss->items) && 0 != count($rss->items) )
      {
        $rss->items = array_slice($rss->items, 0, 3);
        foreach ($rss->items as $item)
        {
        ?>
          <h4><a href='<?php echo wp_filter_kses($item['link']); ?>'><?php echo wp_specialchars($item['title']); ?></a> &#8212; <?php echo human_time_diff(strtotime($item['pubdate'], time())); ?></h4>
          <p><?php echo '<strong>'.date("F, jS", strtotime($item['pubdate'])).'</strong> - '.$item['description']; ?></p>
        <?php
        }
      }
      else
      {
        ?>
        <p><?php printf(__('Newsfeed could not be loaded.  Check the <a href="%s">front page</a> to check for updates.', 'divvaflip'), 'http://am211.amanager.net') ?></p>
        <?php
      }
    ?>
    </div>
    <br style="clear: both" />
   </div>
<?php
}

// ***************************************************************
function ngg_gd_info() {
	if(function_exists("gd_info")){
		echo '<div><h3>'.__('GD support', 'divvaflip').'</h3><ul>';
		$info = gd_info();
		$keys = array_keys($info);
		for($i=0; $i<count($keys); $i++) {
			if(is_bool($info[$keys[$i]]))
				echo "<li> " . $keys[$i] ." : <strong>" . ngg_gd_yesNo($info[$keys[$i]]) . "</strong></li>\n";
			else
				echo "<li> " . $keys[$i] ." : <strong>" . $info[$keys[$i]] . "</strong></li>\n";
		}
	}
	else {
		echo '<div><h3>'.__('No GD support', 'divvaflip').'!</h3><ul>';
	}
	echo '</ul></div>';
}

// ***************************************************************		
function ngg_gd_yesNo($bool){
	if($bool) return __('Yes', 'divvaflip');
	else return __('No', 'divvaflip');
}

// ***************************************************************
function ngg_get_serverinfo() {
// thx to GaMerZ for WP-ServerInfo	
// http://www.lesterchan.net

	global $wpdb;
	// Get MYSQL Version
	$sqlversion = $wpdb->get_var("SELECT VERSION() AS version");
	// GET SQL Mode
	$mysqlinfo = $wpdb->get_results("SHOW VARIABLES LIKE 'sql_mode'");
	if (is_array($mysqlinfo)) $sql_mode = $mysqlinfo[0]->Value;
	if (empty($sql_mode)) $sql_mode = __('Not set', 'divvaflip');
	// Get PHP Safe Mode
	if(ini_get('safe_mode')) $safe_mode = __('On', 'divvaflip');
	else $safe_mode = __('Off', 'divvaflip');
	// Get PHP allow_url_fopen
	if(ini_get('allow_url_fopen')) $allow_url_fopen = __('On', 'divvaflip');
	else $allow_url_fopen = __('Off', 'divvaflip'); 
	// Get PHP Max Upload Size
	if(ini_get('upload_max_filesize')) $upload_max = ini_get('upload_max_filesize');	
	else $upload_max = __('N/A', 'divvaflip');
	// Get PHP Max Post Size
	if(ini_get('post_max_size')) $post_max = ini_get('post_max_size');
	else $post_max = __('N/A', 'divvaflip');
	// Get PHP Max execution time
	if(ini_get('max_execution_time')) $max_execute = ini_get('max_execution_time');
	else $max_execute = __('N/A', 'divvaflip');
	// Get PHP Memory Limit 
	if(ini_get('memory_limit')) $memory_limit = ini_get('memory_limit');
	else $memory_limit = __('N/A', 'divvaflip');
	// Get actual memory_get_usage
	if (function_exists('memory_get_usage')) $memory_usage = round(memory_get_usage() / 1024 / 1024, 2) . __(' MByte', 'divvaflip');
	else $memory_usage = __('N/A', 'divvaflip');
	// required for EXIF read
	if (is_callable('exif_read_data')) $exif = __('Yes', 'divvaflip'). " ( V" . substr(phpversion('exif'),0,4) . ")" ;
	else $exif = __('No', 'divvaflip');
	// required for meta data
	if (is_callable('iptcparse')) $iptc = __('Yes', 'divvaflip');
	else $iptc = __('No', 'divvaflip');
	// required for meta data
	if (is_callable('xml_parser_create')) $xml = __('Yes', 'divvaflip');
	else $xml = __('No', 'divvaflip');
	
?>
	<li><?php _e('Operating System', 'divvaflip'); ?> : <strong><?php echo PHP_OS; ?></strong></li>
	<li><?php _e('Server', 'divvaflip'); ?> : <strong><?php echo $_SERVER["SERVER_SOFTWARE"]; ?></strong></li>
	<li><?php _e('Memory usage', 'divvaflip'); ?> : <strong><?php echo $memory_usage; ?></strong></li>
	<li><?php _e('MYSQL Version', 'divvaflip'); ?> : <strong><?php echo $sqlversion; ?></strong></li>
	<li><?php _e('SQL Mode', 'divvaflip'); ?> : <strong><?php echo $sql_mode; ?></strong></li>
	<li><?php _e('PHP Version', 'divvaflip'); ?> : <strong><?php echo PHP_VERSION; ?></strong></li>
	<li><?php _e('PHP Safe Mode', 'divvaflip'); ?> : <strong><?php echo $safe_mode; ?></strong></li>
	<li><?php _e('PHP Allow URL fopen', 'divvaflip'); ?> : <strong><?php echo $allow_url_fopen; ?></strong></li>
	<li><?php _e('PHP Memory Limit', 'divvaflip'); ?> : <strong><?php echo $memory_limit; ?></strong></li>
	<li><?php _e('PHP Max Upload Size', 'divvaflip'); ?> : <strong><?php echo $upload_max; ?></strong></li>
	<li><?php _e('PHP Max Post Size', 'divvaflip'); ?> : <strong><?php echo $post_max; ?></strong></li>
	<li><?php _e('PHP Max Script Execute Time', 'divvaflip'); ?> : <strong><?php echo $max_execute; ?>s</strong></li>
	<li><?php _e('PHP Exif support', 'divvaflip'); ?> : <strong><?php echo $exif; ?></strong></li>
	<li><?php _e('PHP IPTC support', 'divvaflip'); ?> : <strong><?php echo $iptc; ?></strong></li>
	<li><?php _e('PHP XML support', 'divvaflip'); ?> : <strong><?php echo $xml; ?></strong></li>
<?php
}

if ( !class_exists( "CheckPlugin" ) ) {  
	class CheckPlugin {
		/**
		 * URL with the version of the plugin
		 * @var string
		 */
		var $URL = 'myURL';
		/**
		 * Version of thsi programm or plugin
		 * @var string
		 */
		var $version = '1.00';
		/**
		 * Name of the plugin (will be used in the options table)
		 * @var string
		 */
		var $name = 'myPlugin';
		/**
		 * Waiting period until the next check in seconds
		 * @var int
		 */
		var $period = 86400;					
					
		function startCheck() {
			/**
			 * check for a new version, returns true if a version is avaiable
			 */
			
			// use wordpress snoopy class
			require_once(ABSPATH . WPINC . '/class-snoopy.php');
			
			$check_intervall = get_option( $this->name."_next_update" );

			if ( ($check_intervall < time() ) or (empty($check_intervall)) ) {
				if (class_exists(snoopy)) {
					$client = new Snoopy();
					$client->agent = 'DivvaFlip  Version Checker (+http://www.amanager.net/)';
					$client->_fp_timeout = 10;
					if (@$client->fetch($this->URL) === false) {
						return false;
					}
					
				   	$remote = $client->results;
				   	
					$server_version = unserialize($remote);
					if (is_array($server_version)) {
						if ( version_compare($server_version[$this->name], $this->version, '>') )
						 	return true;
					} 
					
					$check_intervall = time() + $this->period;
					update_option( $this->name."_next_update", $check_intervall );
					return false;
				}				
			}
		}
	}
}
// ***************************************************************	

/**
 * WPMU feature taken from Z-Space Upload Quotas
 * @author Dylan Reeve
 * @url http://dylan.wibble.net/
 *
 */

class ngg_SpaceManager {
 
 	function getQuota() {
		if (function_exists(get_space_allowed))
			$quota = get_space_allowed();
		else
			$quota = get_site_option( "blog_upload_space" );
			
		return $quota;
	}
	 
	function details() {
		
		// take default seetings
		$settings = array(

			'remain'	=> array(
			'color_text'	=> 'white',
			'color_bar'		=> '#0D324F',
			'color_bg'		=> '#a0a0a0',
			'decimals'		=> 2,
			'unit'			=> 'm',
			'display'		=> true,
			'graph'			=> false
			),

			'used'		=> array(
			'color_text'	=> 'white',
			'color_bar'		=> '#0D324F',
			'color_bg'		=> '#a0a0a0',
			'decimals'		=> 2,
			'unit'			=> 'm',
			'display'		=> true,
			'graph'			=> true
			)
		);

		$quota = ngg_SpaceManager::getQuota() * 1024 * 1024;
		$used = get_dirsize( constant( "ABSPATH" ) . constant( "UPLOADS" ) );
//		$used = get_dirsize( ABSPATH."wp-content/blogs.dir/".$blog_id."/files" );
		
		if ($used > $quota) $percentused = '100';
		else $percentused = ( $used / $quota ) * 100;

		$remaining = $quota - $used;
		$percentremain = 100 - $percentused;

		$out = "";
		$out .= '<div id="spaceused"> <h3>'.__('Storage Space','divvaflip').'</h3>';

		if ($settings['used']['display']) {
			$out .= __('Upload Space Used:','divvaflip') . "\n";
			$out .= ngg_SpaceManager::buildGraph($settings['used'], $used,$quota,$percentused);
			$out .= "<br />";
		}

		if($settings['remain']['display']) {
			$out .= __('Upload Space Remaining:','divvaflip') . "\n";
			$out .= ngg_SpaceManager::buildGraph($settings['remain'], $remaining,$quota,$percentremain);

		}

		$out .= "</div>";

		echo $out;
	}

	function buildGraph($settings, $size, $quota, $percent) {
		$color_bar = $settings['color_bar'];
		$color_bg = $settings['color_bg'];
		$color_text = $settings['color_text'];
		
		switch ($settings['unit']) {
			case "b":
				$unit = "B";
				break;
				
			case "k":
				$unit = "KB";
				$size = $size / 1024;
				$quota = $quota / 1024;
				break;
				
			case "g":   // Gigabytes, really?
				$unit = "GB";
				$size = $size / 1024 / 1024 / 1024;
				$quota = $quota / 1024 / 1024 / 1024;
				break;
				
			default:
				$unit = "MB";
				$size = $size / 1024 / 1024;
				$quota = $quota / 1024 / 1024;
				break;
		}

		$size = round($size, (int)$settings['decimals']);

		$pct = round(($size / $quota)*100);

		if ($settings['graph']) {

			$out = '<div style="display: block; margin: 0; padding: 0; height: 15px; border: 1px inset; width: 100%; background-color: '.$color_bg.';">'."\n";
			$out .= '<div style="display: block; height: 15px; border: none; background-color: '.$color_bar.'; width: '.$pct.'%;">'."\n";
			$out .= '<div style="display: inline; position: relative; top: 0; left: 0; font-size: 10px; color: '.$color_text.'; font-weight: bold; padding-bottom: 2px; padding-left: 5px;">'."\n";
			$out .= $size.$unit;
			$out .= "</div>\n</div>\n</div>\n";
		} else {
			$out = "<strong>".$size.$unit." ( ".number_format($percent)."%)"."</strong><br />";
		}

		return $out;
	}

}

?>