<?
function creation_vignette($image , $largeur_max , $hauteur_max , $source , $destination , $prefixe) {
if (!file_exists($source.$image)) { 
echo  "L'image $source $image n'existe pas"; 
exit; 
} 

// On verifie que l'extention du fichier est bien une image jpg,jpeg ou gif 
$ext=strtolower(strrchr($image,'.')); 
if ($ext!=".jpg" AND $ext!=".jpeg" AND $ext!=".gif"){ 
echo  "<br>Votre image doit tre un jpg,jpeg ou gif <br>"; 
exit; 
} 

$size = getimagesize($source.$image); 

$largeur_src=$size[0]; 
$hauteur_src=$size[1]; 

//2ieme verification -> on verifie que le type du fichier est un jpg,jpeg ou gif  
// $size[2] -> type de l'image : 1 = GIF , 2 = JPG,JPEG 
if ($size[2]!=1 AND $size[2]!=2){ 
echo "<br>Format non support<br>"; 
exit; 
} 

if($size[2]==1){ // format gif 
$image_src=imagecreatefromgif($source.$image); 
} 

if($size[2]==2){ // format jpg ou jpeg 
$image_src=imagecreatefromjpeg($source.$image); 
} 

// on verifie que l'image source ne soit pas plus petite que l'image de destination 
if ($largeur_src>$largeur_max || $hauteur_src>$hauteur_max)
{ 
$r1=$largeur_max/$hauteur_max;// 550/370 -> 1,25 // largeur 1,25 x + grande que hauteur
$r2=$largeur_src/$hauteur_src;// 1000/900 -> 1,111 || 2000/900 -> 2,222 || 900/1000 -> 0,9
//  largeur 1,11 x + grande que hauteur mais le rapport doit etre de mini 1,25 => la hauteur est trop gande

	// si la largeur est plus grande que la hauteur 
	if($r1<=$r2)
	{ 
	$ratio=$largeur_max/$largeur_src; 
	}else{ 
	$ratio=$hauteur_max/$hauteur_src; 
	} 
	
$image_dest=imagecreatetruecolor(round($largeur_src*$ratio), round($hauteur_src*$ratio)); 
imagecopyresampled($image_dest,$image_src,0,0,0,0,round($largeur_src*$ratio),round($hauteur_src*$ratio),$largeur_src,$hauteur_src); 

//imagecopyresampled
//imagecopyresized	
	if(!imagejpeg($image_dest, $destination.$prefixe.$image,'96')){ 
echo  "la cration de la vignette a echoue pour l'image $image"; 
exit; 
}

}else{ 
$ratio=1; // l'image cree sera identique  l'originale 
//echo $source.$image.' - '.$destination.$image;

copy($source.$image,$destination.$image); 
} 


} 

//##########################
//##########################








function vide_rep($rep)
{
   if ($dossier = opendir($rep)) 
   {
       while (($fichier = readdir($dossier)) != false) 
	   {
	 if(is_file($rep.$fichier))
	   {
unlink($rep.$fichier); 
		}
       }
   closedir($dossier);
   }
}

//##########################
//##########################

function copie_rep($rep,$rep_copie)
{
   if ($dossier = opendir($rep)) 
   {
       while (($fichier = readdir($dossier)) != false) 
	   {
	 if(is_file($rep.$fichier))
	   {
copy($rep.$fichier, $rep_copie.$fichier); 
		}
       }
   closedir($dossier);
   }
}


//##########################
//##########################

function count_files($folder, $ext, $subfolders) 
{ 
     // on rajoute le /  la fin du nom du dossier s'il ne l'est pas 
     if(substr($folder, -1) != '/') 
        $folder .= '/'; 
      
     // $ext est un tableau? 
     $array = 0; 
     if(is_array($ext)) 
        $array = 1; 

     // ouverture du rpertoire 
     $rep = @opendir($folder); 
     if(!$rep) 
        return -1; 
         
     $nb_files = 0; 
     // tant qu'il y a des fichiers 
     while($file = readdir($rep)) 
     { 
        // rpertoires . et .. 
        if($file == '.' || $file == '..') 
         continue; 
         
        // si c'est un rpertoire et qu'on peut le lister 
        if(is_dir($folder . $file) && $subfolders) 
            // on appelle la fonction 
         $nb_files += count_files($folder . $file, $ext, 1); 
        // vrification de l'extension avec $array = 0 
        else if(!$array && substr($file, -strlen($ext))== $ext) 
         $nb_files++; 
        // vrification de l'extension avec $array = 1    
        else if($array && in_array(substr($file, -strlen($ext)), $ext)) 
         $nb_files++; 
     } 
      
     // fermeture du rep 
     closedir($rep); 
     return $nb_files; 
}  


//##########################
//##########################


//##########################
//##########################


function copydir($origine , $destination) {
$dossier=opendir($origine);
/* 
if (file_exists($destination)){ return 0;} 
mkdir($destination, fileperms($origine)); 
*/
$total = 0; 

while ($fichier = readdir($dossier)) { 
$l = array('.', '..'); 
if (!in_array( $fichier, $l)){ 
if (is_dir($origine."/".$fichier)){
//
if (@!$opendir = opendir($destination . "/" . $fichier))
mkdir($destination."/".$fichier, 0777);
//
$total += copydir("$origine/$fichier", "$destination/$fichier"); 
} else { 
copy("$origine/$fichier", "$destination/$fichier"); 
$total++; 
} 
} 
} 
return $total;

} 







function clr_dir($dir) {
if(@ ! $opendir = opendir($dir)) { 
return false; 
} 
while(false !== ($readdir = readdir($opendir))) { 
if($readdir !== '..' && $readdir !== '.') { 
$readdir = trim($readdir); 
if(is_file($dir.'/'.$readdir)) { 
if(@ ! unlink($dir.'/'.$readdir)) { 
return false; 
} 
} elseif(is_dir($dir.'/'.$readdir)) { 
// Calls itself to clear subdirectories 
if(! clr_dir($dir.'/'.$readdir)) { 
return false; 
} 
} 
} 
} 
closedir($opendir); 

return true; 


} 





function clr_dir_tout($dir) {
if(@ ! $opendir = opendir($dir)) { 
return false; 
} 
while(false !== ($readdir = readdir($opendir))) { 
if($readdir !== '..' && $readdir !== '.') { 
$readdir = trim($readdir); 
if(is_file($dir.'/'.$readdir)) { 
if(@ ! unlink($dir.'/'.$readdir)) { 
return false; 
} 
} elseif(is_dir($dir.'/'.$readdir)) { 
// Calls itself to clear subdirectories 
if(! clr_dir($dir.'/'.$readdir)) { 
return false; 
} 
} 
} 
} 
closedir($opendir); 
if(@ ! rmdir($dir)) { 
return false; 
} 
return true; 


} 



    ?>