(function() {
	tinyMCE.importPluginLanguagePack("divvaflip_gallery");

	var TinyMCE_divvaflip_gallery = {
		getInfo: function() {
			return {
				longname: 'DivvaFlip',
				author: 'DivvaPlugin',
				authorurl: 'http://www.divva-plugins.com',
				infourl: 'http://www.divva-plugins.com',
				version: 1
			};
		},

		getControlHTML: function(control_name){
			switch (control_name) {
				case "divvaflip_gallery":
					return tinyMCE.getButtonHTML(control_name, "lang_divvaflip_gallery_button", "{$pluginurl}/images/gallery.png", "divvaflip_gallery");
					break;
				default:
					return "";
			}

			return "";
		},

	execCommand : function(editor_id, element, command, user_interface, value) {
	 
	 	// Handle commands
		switch (command) {
			// Remember to have the "mce" prefix for commands so they don't intersect with built in ones in the browser.
			case "divvaflip_gallery":
				// Do your custom command logic here.
				divvaflip_buttonscript();
				return true;
		}
		// Pass to next handler in chain
		return false;
	}

};


	tinyMCE.addPlugin("divvaflip_gallery", TinyMCE_divvaflip_gallery);
})();
