/**
 * DivvaFlip Gallery plugin. based largely on the wordpress plugin, since it does about the same thing
 */
(function(){

	tinymce.PluginManager.requireLangPack('divvaflip_gallery');

	tinymce.create('tinymce.plugins.DivvaFlipGallery', {
		init: function(ed, url){

			ed.addCommand('DIVVAFLIP_Gallery', function(){
				ed.windowManager.open({
					file : url + '/window.php',
					width : 360 + ed.getLang('divvaflip.delta_width', 0),
					height : 210 + ed.getLang('divvaflip.delta_height', 0),
					inline : 1
				}, {
					plugin_url : url // Plugin absolute URL
				});
			});
			
			ed.addButton('divvaflip_gallery', {
				title: 'divvaflip_gallery.button',
				image: url + '/img/gallery.png',
				cmd: 'DIVVAFLIP_Gallery'
			});



		},

		getInfo: function(){
			return {
				longname: 'DivvaFlip',
				author: 'DivvaPlugin',
				authorurl: 'http://www.divva-plugins.com',
				infourl: 'http://www.divva-plugins.com',
				version: '1.0'
				};
		}
	});




	// Register plugin
	tinymce.PluginManager.add('divvaflip_gallery', tinymce.plugins.DivvaFlipGallery);
})();
