<?php

$wpconfig = realpath("../../../../../wp-config.php");

if (!file_exists($wpconfig))  {
	echo "Could not found wp-config.php. Error in path :\n\n".$wpconfig ;	
	die;	
}// stop when wp-config is not there

require_once($wpconfig);
require_once(ABSPATH.'/wp-admin/admin.php');

// check for rights
if(!current_user_can('edit_posts')) die;

global $wpdb;

?>

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>DivvaFlip Gallery</title>
	<meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php echo get_option('blog_charset'); ?>" />
    
<script language="javascript" type="text/javascript" src="<?php echo get_option('siteurl') ?>/wp-includes/js/tinymce/tiny_mce_popup.js"></script>
<script language="javascript" type="text/javascript" src="<?php echo get_option('siteurl') ?>/wp-includes/js/tinymce/utils/mctabs.js"></script>
<script language="javascript" type="text/javascript" src="<?php echo get_option('siteurl') ?>/wp-includes/js/tinymce/utils/form_utils.js"></script>

<script language="JavaScript">

function getCheckedValue(radioObj) {
	if(!radioObj)
		return "";
	var radioLength = radioObj.length;
	if(radioLength == undefined)
		if(radioObj.checked)
			return radioObj.value;
		else
			return "";
	for(var i = 0; i < radioLength; i++) {
		if(radioObj[i].checked) {
			return radioObj[i].value;
		}
	}
	return "";
}


function insert_divvaflip() 
{

	var code='';

	var id = document.getElementById('divvaflip-gallery').value;
	var type = getCheckedValue(document.getElementsByName('type'));

	code="[wp_divvaflip]"+type+","+id+"[/wp_divvaflip]";
	


	if(window.tinyMCE) 
	{
		window.tinyMCE.execInstanceCommand('content', 'mceInsertContent', false, code); 
		tinyMCEPopup.editor.execCommand('mceRepaint');
		tinyMCEPopup.close();
	}
	
	
	
	
}

	
	
</script>

</head>
<body>
<!-- <form onsubmit="insertLink();return false;" action="#"> -->
<form name="DivvaFlip" action="#">


<?
$gallerylist = $wpdb->get_results("SELECT * FROM $wpdb->divvaflip ORDER BY id ASC");
if($gallerylist) {
?>
<div class="tabs"></div>
<div class="panel_wrapper">
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td>
DivvaFlip : 
<select name="divvaflip-gallery" id="divvaflip-gallery">    
<?
	foreach($gallerylist as $gallery)
	{
	echo '<option value="'.$gallery->id.'">'.$gallery->title.'</option>
	';
	}
?>
</select>
&nbsp;</td>
  </tr>
  <tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td><?php _e("Direct link", 'divvaflip'); ?> :
      <input name="type" type="radio" id="type1" value="direct" checked></td>
  </tr>
  <tr>
    <td><?php _e("Embedded DivvaFlip", 'divvaflip'); ?> : 
      <input type="radio" name="type" id="type2" value="divvaflip"></td>
  </tr>
  <tr>
    <td><?php _e("Mini embedded DivvaFlip", 'divvaflip'); ?> :
      <input type="radio" name="type" id="type3" value="divvaflipmini"></td>
  </tr>
</table>
</div><br>
<br>
<br>
  <div class="mceActionPanel">
		<div style="float: left">
			<input type="button" id="cancel" name="cancel" value="<?php _e("Cancel", 'divvaflip'); ?>" onClick="tinyMCEPopup.close();" />
		</div>
<? } ?>
<div style="float: right">
			<input type="button" id="insert" name="insert" value="Insert" onClick="insert_divvaflip();" />
		</div>
	</div>
</form>
</body>
</html>
