<?php
/*
Plugin Name: wp_divvaflip
Plugin Script: wp_divvaflip.php
Plugin URI: http://www.divva-plugins.com
Description: Manage your Divvaflip ! Add your pages and start browsing your book.
Version: 2.6
Author: Divvaflip
Author URI: http://www.divva-plugins.com
*/

if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) { die('You are not allowed to call this page directly.'); }
global $wpdb, $wp_version, $wpmu_version, $wp_roles;

$_GET["id_divvaflip"] = (int) $_GET["id_divvaflip"];

if ( ABSPATH=='') define('ABSPATH', substr(dirname(__FILE__),0,strpos(dirname(__FILE__),'/wp-includes')));
$plugin_dir = ABSPATH.'wp-content/plugins/wp_divvaflip/';
include_once ($plugin_dir.'param.php');
include_once ($plugin_dir.'function.php');


// Load language
function wp_divvaflip_init_lang ()
{
	load_plugin_textdomain('divvaflip','wp-content/plugins/wp_divvaflip/lang');
}
// load language file
add_action('init', 'wp_divvaflip_init_lang');




/// INSERT
$wpdb->divvaflip = $table_prefix . 'divvaflip';

if($wpdb->get_var("SHOW TABLES LIKE '".$wpdb->divvaflip."'") == null) 
{
	$divvaflip_table = "CREATE TABLE $wpdb->divvaflip (
	id int(10) unsigned NOT NULL auto_increment,
	title varchar(255) default '',
	width varchar(25)  default '',
	height varchar(25) default '',
	mini_width varchar(25) default '',
	mini_height varchar(25) default '',
	background INT(1),
	bgcolor varchar(10) default '',
	music INT(1),
	zoom INT(1),
	pages varchar(20) default '',
	mini_pages varchar(20) default '',
	pages_align_h varchar(20) default '',
	pages_align_v varchar(20) default '',
	bgcolor_divvaflip varchar(10) default '',
	mini_bgcolor_divvaflip varchar(10) default '',
	bgcolor_page varchar(10) default '',
	redimensionner INT(1),
	language varchar(10) default 'en', 
	PRIMARY KEY  (id)
	)"; 
	 
	$wpdb->query($divvaflip_table);
	$divvaflip_data="INSERT $wpdb->divvaflip VALUES (1, 'My DivvaFlip', '300', '225', '70', '100','', '222222','',1,'6','4','center','center','333333','333333','111111','1','en');";
	$wpdb->query($divvaflip_data);
}



	
if ( is_admin() ) {
add_action('admin_menu', 'wp_divvaflip_menu');
}




function wp_divvaflip_menu() {
  global $wpdb;
  $plugin_path = "./wp-content/plugins/wp_divvaflip/";
  add_menu_page('Divvaflip', 'Divvaflip', 8, 'wp_divvaflip/wp_divvaflip.php', 'wp_divvaflip_configuration');
  add_submenu_page( $plugin_path.'wp_divvaflip.php',__('Manage','divvaflip'),__('Managing my DivvaFlip','divvaflip'),8,$plugin_path.'manage.php');
  add_submenu_page( $plugin_path.'wp_divvaflip.php',__('About','divvaflip'),__('About','divvaflip'),8,$plugin_path.'about.php');
}

function wp_divvaflip_configuration() 
{
  global $wpdb,$plugin_dir,$rep_images,$rep_imagesm,$rep_imageso;
	


  // DELETE CATALOG
		if($_GET["mode"]=='delete' && $_GET["id_divvaflip"]!='')
		{
			$wpdb->query("DELETE FROM $wpdb->divvaflip WHERE id = '".$_GET["id_divvaflip"]."'");
		
			$rep_divva=$plugin_dir.$_GET["id_divvaflip"];
			clr_dir_tout($rep_divva.'/'.$rep_images);
			clr_dir_tout($rep_divva.'/'.$rep_imagesm);
			clr_dir_tout($rep_divva.'/'.$rep_imageso);		
			clr_dir_tout($rep_divva);

		}
	// END DELETE
	
  ?>
 <link rel='stylesheet' href='<?=get_settings('siteurl')?>/wp-content/plugins/wp_divvaflip/style.css' type='text/css' />
    <div class="wrap">
	  <h2><? _e('DivvaFlip : Interactive Catalogue','divvaflip') ; ?></h2>
	  

	  <h3><? _e('My DivvaFlip','divvaflip') ; ?></h3>
	  <table border="0" cellspacing="0" cellpadding="0">	
	  
	  <tr><td colspan="5" align="left">
		  <form method="post" action="admin.php?page=wp_divvaflip/manage.php&mode=add">
			<input name="divvaflip_add" class="button" id="divvaflip_add" tabindex="10" value="<?  _e('New DivvaFlip','divvaflip');?>" type="submit">
		  </form>
	</td></tr>
	
       <tr>
          <td valign="top">
	  <table cellpadding="2" cellspacing="2">
<?php			
$gallerylist = $wpdb->get_results("SELECT * FROM $wpdb->divvaflip ORDER BY id ASC");
if($gallerylist) {

	echo '<thead><tr>
	<th class="titeldivva"><strong>'; _e('ID','divvaflip'); echo ' </strong></th>
	<th class="titeldivva" align="left"><strong>'; _e('TITLE','divvaflip'); echo '</strong></th>
	<th class="titeldivva"><strong>'; _e('PAGES','divvaflip'); echo '</strong></th>
	<th class="titeldivva"><strong>'; _e('MODIFY','divvaflip'); echo '</strong></th>
	<th class="titeldivva"><strong>'; _e('DELETE','divvaflip'); echo '</strong></th>
	</tr></thead>'; 

	foreach($gallerylist as $gallery) {
		$class = ( $class == '1' ) ? '' : '1';
		$gid = $gallery->id;
		?>
		<tr>
			<td class="tddivva<?=$class?>"><?php echo $gid; ?></th>
			<td class="tddivva<?=$class?>"><?php echo $gallery->title; ?></td>
			<td class="tddivva<?=$class?>"><?php echo $gallery->pages ; ?></td>
			<td class="tddivva<?=$class?>"><a href="admin.php?page=wp_divvaflip/manage.php&id_divvaflip=<?=$gid?>&mode=edit" class='edit'> <?php _e('Edit') ?></a></td>
			<td class="tddivva<?=$class?>"><a href="admin.php?page=wp_divvaflip/wp_divvaflip.php&amp;id_divvaflip=<?=$gid?>&mode=delete" class="delete" onclick="javascript:check=confirm( '<?php _e("Delete this catalog ?",'divvaflip')?>');if(check==false) return false;"><?php _e('Delete','divvaflip') ?></a></td>
		</tr>
		<?php
	}
} else {
	echo '<tr><td colspan="5" align="center"><strong>'; _e('No entries found','divvaflip'); echo '</strong></td></tr>';
}
?>	
	  </table>
&nbsp;</td>

          <td width="20">&nbsp;</td>
          <td valign="top"><div id="wphead2"><? include_once($plugin_dir.'news.php'); ?></div></td>
        </tr>
      </table>
    
    </div>
<?
}



function wp_divvaflip_init() {
	


	function wp_divvaflip_header() {
	$wp_divvaflip_javascript_swfobject = get_settings('siteurl'). '/wp-content/plugins/wp_divvaflip/js/swfobject.js';
	echo'
	<script src="'. $wp_divvaflip_javascript_swfobject .'" type="text/javascript"></script>
	';
	}
	
	function wp_divvaflip_filter($text) {
	global $wpdb;
	$p=0;
	
	foreach (preg_split('|(\[wp_divvaflip\].+,.+\[/wp_divvaflip\])|i', $text, -1, PREG_SPLIT_DELIM_CAPTURE) as $token) {
		$p++;
		if (preg_match('|(\[wp_divvaflip\].+,.+\[/wp_divvaflip\])|i', $token)) 
		{
            
			$name = $token;
			$name2=strtolower($name);
			$getrid = array('[wp_divvaflip]','[/wp_divvaflip]',' ','\n','<br>','<br />');
			$name2=str_replace($getrid,'',$name2);
				
	
				$namex = explode(',',$name2);

				$type = $namex[0];
				$id_divvaflip = $namex[1];
				
		$dl = $wpdb->get_results("SELECT title,mini_width,mini_height,width,height,language FROM $wpdb->divvaflip id WHERE id='".$id_divvaflip."' ");
		
		if($type=="divvaflipmini")
		{
		$width_divvaflip = $dl[0]->mini_width*2+20;
		$height_divvaflip = $dl[0]->mini_height+40;
		$type_divvaprint="divvaflipmini";
		$height_contener=0;
		}
		elseif($type=="divvaflip")
		{
		$width_divvaflip = $dl[0]->width*2+20;
		$height_divvaflip = $dl[0]->height+60;
		$type_divvaprint="divvaflipin";
		$height_contener=round(305+($dl[0]->height/2));
		}
		$divvaflip_language=$dl[0]->language;


$output = '
<div id="flashcontent'.$id_divvaflip.$p.'">
  divvaflip
</div>
<script language="JavaScript" type="text/JavaScript">
var so = new SWFObject("'.get_settings('siteurl').'/wp-content/plugins/wp_divvaflip/script/'.$type_divvaprint.'.swf?height_contener='.$height_contener.'&lang='.$divvaflip_language.'&id_divvaflip='.$id_divvaflip.'&url_divvaflip='.get_settings('siteurl').'/wp-content/plugins/wp_divvaflip/", "divvaflip", "'.$width_divvaflip.'", "'.$height_divvaflip.'", "8", "#");
so.write("flashcontent'.$id_divvaflip.$p.'");
</script>
';

		if($type=="direct")
		{
		$output = '<a href="'.get_settings('siteurl').'/wp-content/plugins/wp_divvaflip/divvaflip.php?id_divvaflip='.$id_divvaflip.'" target="_blank">'.$dl[0]->title.'</a>';
		}


				$flashedtext .= $output;
                          
        }else{$flashedtext .= $token;}
    }

    return $flashedtext;
	
	
	}
	add_filter('the_content', 'wp_divvaflip_filter');
}

// Load tinymce button 




class DIVVAFLIPAdmin {
	function tinymcePlugin($plugins){
		$plugins[] = "-divvaflip_gallery";
		return $plugins;
	}

	function tinymceButton($buttons){
		$buttons[] = "separator";
		$buttons[] = "divvaflip_gallery";
		return $buttons;
	}


	function loadTinymcePlugin(){
		echo "tinyMCE.loadPlugin('divvaflip_gallery', '". get_option("siteurl") . "/wp-content/plugins/wp_divvaflip/tinymce/divvaflip_gallery');\n";
	}
	
	function tinymce3Plugin($plugins){
		$plugins["divvaflip_gallery"] = get_option("siteurl") . '/wp-content/plugins/wp_divvaflip/tinymce3/divvaflip_gallery/editor_plugin.js';
		return $plugins;
	}
	
	function insert_divvaflip_script() {	
		echo "\n"."
		<script language=\"JavaScript\" type=\"text/JavaScript\">
			function divvaflip_buttonscript()	{ 
			if(window.tinyMCE) {
	
				var template = new Array();
		
				template['file'] = '" . get_option("siteurl") . "/wp-content/plugins/wp_divvaflip/tinymce/divvaflip_gallery/window.php';
				template['width'] = 360;
				template['height'] = 210;
		
				args = {
					resizable : 'no',
					scrollbars : 'no',
					inline : 'yes'
				};
		
				tinyMCE.openWindow(template, args);
				return true;
			} 
		} 
		</script>"; 
		return;
	}
	
	
}

//////////////



if($wp_version < "2.4.0") {
	add_filter("mce_plugins", array("DIVVAFLIPAdmin", "tinymcePlugin"));
	add_action('edit_page_form', array("DIVVAFLIPAdmin", "insert_divvaflip_script"));
	add_action('edit_form_advanced', array("DIVVAFLIPAdmin", "insert_divvaflip_script"));
	add_action("tinymce_before_init", array("DIVVAFLIPAdmin", "loadTinymcePlugin"));
	

	
} else {
	add_filter("mce_external_plugins", array("DIVVAFLIPAdmin", "tinymce3Plugin"));
}
			
add_filter("mce_buttons", array("DIVVAFLIPAdmin", "tinymceButton"));

add_action('wp_head', 'wp_divvaflip_header');
add_action('plugins_loaded', 'wp_divvaflip_init');




?>
